; ************************************************************************
; *                         zMolMass.asm   (c)) 1998                     *
; ************************************************************************
; This program was written by Olivier "Bones" SANNIER. You can use it and 
; distribute it freely but never forget to mention my name. you also can
; improve it but never forget to say that your program was based on mine.
; this program is for ti86 and will only work on it. It's an helpful
; apllet which gives you the molar masse of a molecule just with it's
; raw formula. ie you type in CH4 and it will answer you 16. 
; In order to run this program, you must have loaded constant into your 
; calc. All the const used begin with a capital M and the following is the
; symbol of the chimic element (ie : MC, MNa, MZn, MHg, MI...). 
; I think it's a pretty good example of OP register use in conjonction 
; with Math routine. It also shows how to get values from basics variables 
; such as constants with the help of _FindSym routine and an undocumented 
; routine : $4633
; Feel free to add comments in order to improve comprehension for beginners
; cause it's very hard to understand if you begin asm programming but very
; easy for profesionals. 
; I developped it with ASSEMBLY STUDIO 2.0 one of the best ti86 tool i've
; ever seen for asm developping. So I don't know if the text directive is 
; recognized by all compilers (ie TASM). If you encounter problems, 
; replace '.text' by '.db' and add ',0' at the end of the string. It will 
; solve the problem.
;
; Please mail me your comments and why not greatings at
; _Bones@Caramail.com
; I'll answer you in the limit of my abilities.
;
; This file takes part in package named MolMass.zip which contains a 86g
; file with this program compiled, its launcher and many chemistry
; constant definitions. It can be distributed as a standalone file but,
; in this case, please mention where to find the complete package.

#include "ti86asm.inc"

; ti86und.inc is not a standard so I give you here the values of all the 
; aliases contained in it and used in my prog.
; _jforcmdNochar = 409Ch                ; restore stack and ends program
; _ldHlz         = 437Bh				; write b zeros at HL location
; _cpHlDe        = 403Ch				; compare HL and DE affects z flag
; _DispOP1       = 515Bh				; shows OP1 as a ti-OS result
; _CkOP1Fp0      = 449Bh				; check if op1 is zero (z flag)
; _StoANS        = 4C9Fh				; save OP1 in ANS variable
; _HomeUp        = 4A95h				; cursor at upper left corner
#include "ti86und.inc"

#include "ti86ops.inc"
#include "ti86math.inc"

.org _asm_exec_ram

; Preparing the screen and putting initial values in variables

	Call	_clrscrn					; screen is clean now
	Call	_HomeUp						; cursor is at upper left corner
	Call	_RunIndicOff				; no run indicator

	ld		hl, CharNumber					
	ld		(hl), 0						; no character entered yet

	ld		hl, String					; place of the entered string
	ld		b, 20
	Call	_ldHlz						; nothing in the string

	set		CurOn, (Iy+CurFlags)		; we want to see the cursor
	set		CurAble, (Iy+CurFlags)		; we want it to flash

	ld		hl, Prompt					; hl = prompt address
	call	_puts						; show prompt
	call	_newline					; equivalent to return on a PC

; Here begins the main loop.
WaitKey:
	Call	_getkey						; waits for a key to be pressed

		ld		b, a					; saves a in b (quicker than push)
		ld		a, 32					; a = 32 -> a space
		call	_putmap					; puts this space on screen. I do
			; this to make the cursor char destroyed, else it can create
			; funny things. _putmap don't affect the cursor location.

		ld		a, b					; restore a

	cp		kEnter						; is keypressed Enter ?
	jp		z, Termine					; if Yes then jump to Finish
	cp		kDel						; Was it Del key ?
	jp		z, Suppr					; if yes jump to Suppr
	cp		kLeft						; Was it Left Key ?
	jp		z, Suppr					; if yes deletes the char
		ld		b, a					; saves a
		ld		hl, CharNumber			; hl gets the adress of Char number
		ld		a, (hl)					; a equals char number
		cp		20						; compares to 20
		jp		P, WaitKey				; if a > 20 then no more character
		ld		a, b					; restore a

; All the following test are done to be sure to only deal with the chars 
; we want : Letters and Numbers, nothing else.
	cp		k0						; Was it 0 key ?
	jp		M, WaitKey				; if a < k0 it's not a valid key

	cp		k9+1					; if a < k9+1 (= a<=k9) then it's a
	Jp		M, Number				; number and we process it

	cp		kCapA					; compares a to KCapA
	jp		M, WaitKey				; if a < kCapA it's not a valid key

	cp		kCapZ+1					; if a < KCapZ+1 (= a<=KCapZ) then
	Jp		M, LettreMaj			; it's a capital key and we process it

	cp		ka						; compares a to ka
	jp		M, WaitKey				; if a < ka it's not a valid key

	cp		kz+1					; if a < kz+1 then it's a lower case
	Jp		M, LettreMin			; letter and we procces it

	jp		WaitKey			; if no jump happens we restart waiting
	ret							; this a security ret to prevent crash


; This proc process a number. Means that it shows it on screen, add it at
; the end of the string which contains the formula to process later
Number:
	add		a, 100					; asciize a value in order to show it
	Call	_AddChar				; adds the char to the string
	Call	_putc					; show the char on screen
	Jp		WaitKey					; go back to wait a new key to be ed

;This proc process a Capital. Same functionnality as Number Proc
LettreMaj:
	add		a, 25				; asciize a value to show it
	Call	_AddChar			; see above for comments
	Call	_putc
	Jp		WaitKey


; this proc is nearly the same as Capital but for lower case letters
LettreMin:
	add		a, 31
	Call	_AddChar			; see above for comments
	Call	_putc
	Jp		WaitKey

;-----------------------------------------------------------------------
; This proc adds the char at the end of the string which will be process
; when enter will be pressed
_AddChar:
	ld		hl, CharNumber
	Inc		(hl)					; one char more

	ld		e, (hl)				; e = char number
	ld		d, 0				; with 0 in d, de equals char number

	ld		hl, String-1		; hl equals String minus one
	add		hl, de				; hl = hl + de, so hl points to end 
								; of string

	ld		(hl), a				; we add the char at hl location
	ret

;----------------------------------------------------------------------
; this proc deletes a char by decreasing CharNumber and _CurCol
Suppr:
	ld		hl, (CharNumber)
	ld		de, 0
	call	_cphlde				; compare hl and de (undocumented)

	jp		z, WaitKey			; If there's no char then exit cause
								; i can't del nothing

	ld		hl, _curcol			
	dec		(hl)				; decrease _CurCol

	ld		a, 32
	call	_putmap				; and puts a space to hide the deleted char

	ld		hl, CharNumber
	dec		(hl)				; decrease CharNumber
	jp		WaitKey				; go back to wait a key to be pressed

;-------------------------------------------------------------------------
; This routine ends the prog. Called after Enter was pressed. If neccessary
; it launch ProcessString to show the result
Termine:
	Set		CurLock, (iy+CurFlags)		; cursor is locked off

	ld		hl, CharNumber
	ld		a, (hl)						; a = number of char
	cp		0							; is it 0 ?
	Call	nz, ProcessString			; if not, calls ProcessString cause
									; this procs crash if you call it and 
									; there's nothing to do

	Res		CurLock, (iy+CurFlags)		; Cursor is On
	ret									; leaves prog

;----------------------------------------------------------------------
; this procs process string entered in order to return the value of
; molar mass. it's the heart of the prog and must be viewed with a
; particular attention in order to understand how my prog works.

ProcessString:
	Call	_ZeroOp1					; nothing in op1
	Call	_ZeroOp2					; nothing in op2
	ld		hl, Total					; hl points to the total place
	ld		b, 10	
	call	_ldhlz						; nothing in the total

	ld		hl, NumberPos
	ld		(hl), 0						; No number

	ld		hl, LetterPos
	ld		(hl), 1						; One Letter : The M of Molar Mass

; I put initial values in all the places in want to use cause I'm not sure 
; of the initial value which are put. It could create problems and 
; may crash sometimes

	ld		hl, CharNumber
	ld		b, (hl)						; there's b char to process
; I load the number of char to process in b cause it is used by DJNZ

	ld		hl, String-1				; we place hl at String -1
; It's the initial value of Hl before we start the loop

Bcl1:
		inc		hl						; next character
		ld		a, (hl)					; a contains char value
		push	hl						; saves hl (to save string pointer)
		push	bc						; saves bc (to save loop couter)
		cp		128						; compares a to 128
		jp		P, ProcessNumber		; if a < 128 then it's a number
		pop		bc						; restore bc
		push	bc						; saves bc
; I do that to be sure to have the good value of b. this value is used by
; ProcessLetter procedure and musn't be corrupted

		jp		ProcessLetter			; else it's a letter we'll process 
	
Decompte:
		pop		bc						; restore loop counter
		pop		hl						; restore string pointer
	djnz	Bcl1						; jumps until no char left
	call	UpdateTotal				; update total here cause it sometimes
				; happens that user just wrote one letter or ends its 
				; formula with an element without any number behind

	call	_newline				; equivalent to chr(13) on a pc
	call	_stoANS					; save result value in Ans. I do this
			; so student can use the value in a calculus just after. Very
			; useful for me when I solved Chemistry problems for my exams.
; Please note that you can type into tiOS a command line like this one :
; asm(zMolMAss):25.3*29/Ans
; this is one of the typic use of my prog to solve chemistry problems.

	call	_dispOp1				; shows result value on screen
	ret								; leaves prog

;-----------------------------------------------------------------------
; this procs called when a letter is found in the string being processed
ProcessLetter:
	cp		96
	jp		P, LowerCase			; if positive then it's a lower case
					; in fact I test that : if a > 96 then it's a lower 
					; case. It's the same of testing a-96 to be positive

	ld		d, a					; saves a	(quicker than push and
							; don't creates problems with call cause
							; call puts the PC onto the stack. but it's
							; a bit more dangerous cause some functions
					; are destroying registers so in this case, you must
					; use a push command)

	ld		a, b					; puts b value in a. i must do like
					; that cause all compare operands use a register

	ld		hl, CharNumber			
	ld		e, (hl)					; e = char number
	cp		e						; compare a and e, in fact it compares
					; actual char number with total char number

	ld		a, d					; restore initial value of a
	jp		z, LowerCase			; jump if end of the string cause z 
					; means that actual char number is equal to total char
					; number which means we're at the end of the string
	
	push 	af						; saves a (can't use a load cause 
								; all registry are used by UpdateTotal)
	call	UpdateTotal				; update total
	pop		af						; restores a

	ld		hl, LetterPos
	ld		(hl), 1					; First letter cause when it's a
									; a capital, it's always the first 
									; letter of a chimic element
	ld		hl, NumberPos
	ld		(hl), 0					; No Number
		
LowerCase:
	ld		hl, LetterPos
	inc		(hl)					; one letter more
	ld		e, (hl)
	ld		d, 0					; de equals letter number
	ld		hl, _op1+1				; hl = _op1+1
	add		hl, de					; hl = hl + de
	ld		(hl), a					; puts char at its place in OP1, it's
									; building Constant name, char by char

	jp		Decompte				; jump back to process next char

;-------------------------------------------------------------------
; this proc called when a number is found in the string being processed
ProcessNumber:
	sub		128					; a now contains number value (unasciize it)
	ld		hl, NumberPos
	Inc		(hl)				; one number more

	bit		0, (hl)				; parity test
; must test parity cause OP register use BCD logic. So, if it's an even
; location we must put it saving the value already loaded on the byte
; indicated by the value stored at PosNumber divided by two. We must
; divide PosNumber value by two in order to get the number of the byte
; where to load number value because in one byte, you put two digits.

	jr		nz, odd				; if bit 0 is set then it's an odd number
	ld		hl, NumberPos
	ld		e, (hl)				; e gets the pos of number
	or		a					; 0 in the carry
	rr		e					; e just divided by 2 cause carry is 0
	ld		hl, _op2M-1			; hl gets Op2 mantissa - 1 adress
	ld		d, 0				; puts 0 in d to be sure that we're going
						; to add just e value to hl with the add operand
	add		hl, de				; hl = hl + de

	daa							; a coded in BCD
	ld		d, (hl)
	or		d					; insert d value in a
	ld		(hl), a				; puts back the value
	jr		decompte			; jump back to process next char


odd:
	ld		hl, NumberPos
	ld		e, (hl)				; e gets the number of number
	or		a					; 0 in the carry
	rr		e					; e divided by 2
	ld		hl, _op2M			; start of OP2 mantissa
	ld		d, 0
	add		hl, de				; hl = hl + de
	daa							; a coded in BCD
		or		a					; all this commands are made to put 
		rla							; the 4 lower bits to the 4 higher bits
		or		a					; not very beautiful but it works
		rla							; please tell me how to improve that
		or		a					; but note that _shracc doesn't do the
		rla							; things i want
		or		a
		rla						
	ld		(hl), a				; puts back the value to its place
	jp		Decompte			; go back to the main loop

;-------------------------------------------------------------------------
UpdateTotal:
	ld		hl, _op2			; all these commands are made to get OP2
	ld		(hl), 0				; compliant with OP saving number rules.
	ld		hl, NumberPos		; see help in ASSEMBLY STUDIO 2.0 at
	ld		e, (hl)				; OP registers section to know more
	dec		e
	ld		hl, _op2+1
	ld		(hl), e
	Inc		hl
	ld		(hl), $FC

	Call	_Op1ToOp3			; Saves Op1 in OP3
	Call	_Op2ToOp1			; Puts OP2 in OP1
; this is done cause the next routine can just use OP2 and I want to test
; if OP2 is zero without loosing OP1 value.

	Call	_ckOp1fp0			; Test OP1 to be zero, in fact test OP2
	jr		nz, NotZero			; jump if not zero
	ld		hl, _op2+3			; else write 1 in BCD into OP2
	ld		(hl), $10
	ld		hl, _op2+1
	ld		(hl), 0
NotZero:
	Call	_Op3ToOp1			; Restore OP1 from OP3
	

	ld		hl, _op1
	ld		(hl), $08			; variable type -> $08 is a constant
	ld		hl, _op1 + 2
	ld		(hl), 'M'			; M in front for constant name

	ld		hl, LetterPos
	ld		e, (hl)
	ld		hl, _op1+1
	ld		(hl), e				; Constant number of char

	ld		d, 0
	ld		hl, _Op1+2
	add		hl, de
	ld		(hl), 0				; puts a ending  0 in case it needs to be
								; show onto the screen

	Rst		10h						; call _FindSym
	jp		c, Exit			; if const don't exist we exit
	ld 		a, b					; a = b
	ex 		de, hl					; hl = de
; Makes AHL absolute pointer from BDE value
	call 	$4633					; gets page and offset in this page
									; from the absolute pointer in AHL
	set		6, a				; set cause it's a ram page
	out		(5), a				; loads this page
	inc		a
	out		(6), a				; and the following page
	ld 		bc, $4000			; bc = $4000 (length of a ram page)
	or 		a					; sets carry to 0 cause 'or a' just do that
	sbc 	hl, bc				; hl = hl - bc

; must decrease hl cause the $4633 function returns a value of offset 
; which is from $8000 to $C000, this function considers that you loaded
; the page in the common ram pages area. But, in order to prevent problems
; we put the page returned in the first page loading area ($4000-$8000) 
; and the next page into the following area. So we must decrease hl by 
; $4000 to make it a valid pointer. this is done in case the values to get
; are beginning into one page and finishing into the next one.
; (in normal case, it don't appear to be possible but...)

	ld		de, _OP1
	ld		bc, 10
	Ldir						; loads constant value in OP1

	ld 		a, %00001101		; Go back to default pages
	out 	(5), a
	ld 		a, %01000001
	out 	(6), a

	rst		28h					; call _fpmult -> OP1 = OP1 * OP2
; at this step, OP1 contains the value to be added to the total. So we
; must get the total value and put it in OP2 to go on with an addition

	ld		hl, Total
	ld		de, _op2
	ld		bc, 10
	ldir						; gets total value in op2

	rst		30h					; Call _fpadd -> OP1 = OP1 + OP2

; Here, OP1 contains the new total value. We now must save it but we can't
; do it into an OP register cause all MAth routines seem to destroy all OP 
; registers to achieve their work. So i wrote the total value into memory,
; at the end of my prog, in the variable section.
	ld		hl, _op1
	ld		de, Total
	ld		bc, 10				; only ten characters
	Ldir						; saves total value

	Call	_ZeroOp2			; nothing in op2 to prevent problems when
								; using OP2 at next loop

	ret							; returns to calling routine

;--------------------------------------------------------
; This procs exits from prog when a constant name hasn't been found.
Exit:
	Set		CurLock, (Iy+CurFlags)	; no cursor visible
	call	_newline				; return to line
	ld		hl, _op1+2
	call	_puts					; shows unfounded variable name
	ld		hl, NotFound
	call	_puts					; and add an explanation sentence
	call	_newline				; returns from line
	jp		_jforcecmdnochar		; quickly exits restoring stack and
						; some flags like CurLock (undocumented)





;***********************************************************************
;--------------------------  VARIABLE  SPACE  --------------------------
;***********************************************************************
; Here are all the memory locations I use as variables. I put it all at
; the end of my prog cause I'm sure no ti functions will come here to
; corrupt my datas. It's a safer way of programming than putting it in
; free RAM location sometimes mentionned in some source and tutorials.



; CharNumber contains the number of chars there's in the string the user
; has entered. ie if CH4 was entered, it will contain 3
CharNumber:
	.db 0 

; NumberPos is used during string processing to know in which nibble I
; must store the readed number value. ie when I process C6H12O6, at a
; time, the char read will be the '1' after H. so in this case, NumberPos
; contains 1. when i finish processing the 1, I read the '2' and now
; Number Pos contains 2 cause it's the second number i've encountered
; without any letter between.
NumberPos:
	.db 0

; LetterPos has nearly the same functionnality as NumberPos but for 
; letters. In this case, i use it to know in which byte of Op1 I must 
; write the letter in order to build Constant Name.
LetterPos:
	.db 0

; Total is a memory place used to store the total value during string
; process. I must use a personal ram location instead of an OP cause
; i realize during my test period that the math routines i use are
; destroying all op register. so to be sure to keep the good total value,
; I save it into a personal ram location
Total:
	.db "          "

; String is the place where I store the string entered by user. there's 
; just twenty chars cause I don't wan't the formula to be longer.
String:
	.db "                    "

; Prompt and NotFound are sentences used to make the prog a bit more
; comprehensive for user when it begins or when it crash due to a non 
; existing constant.
Prompt:
	.text "Raw formula :"
NotFound:
	.text " doesn't exist"

; End of file. Nothing more to tell you. Hope you understand my so bad
; and ugly english but I'm just a little french student 8-)
; 
; Mail me your comments at
; _Bones@Caramail.com
;
.end
